﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;

namespace Misalignment
{
    public partial class Form1 : Form
    {
        const float cZoomFactor = 0.25f;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnOpenExcel_Click(object sender, EventArgs e)
        {
            string fileName = GetFileName();
            fpSpread1.OpenExcel(fileName);
        }

        private void btnAddShape_Click(object sender, EventArgs e)
        {
            //Adds a rectangular border from the active cell
            AddBorderToArea();
        }

        private void btnZoomOut_Click(object sender, EventArgs e)
        {
            if (fpSpread1.ZoomFactor <= 0.25)
            {
                fpSpread1.ZoomFactor = 0.5f;
            }

            fpSpread1.ZoomFactor -= cZoomFactor;
            label1.Text = "Zoom Factor=" + fpSpread1.ZoomFactor.ToString();
        }

        private void btnZoomIn_Click(object sender, EventArgs e)
        {
            if (fpSpread1.ZoomFactor >= 4)
            {
                fpSpread1.ZoomFactor = 3.75f;
            }
            fpSpread1.ZoomFactor += cZoomFactor;
            label1.Text = "Zoom Factor=" + fpSpread1.ZoomFactor.ToString();
        }

        private string GetFileName()
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            string fileName = string.Empty;
            openFileDialog.Filter = "Excel|*.xlsx";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                fileName = openFileDialog.FileName;
            }
            return fileName;
        }

        private void AddBorderToArea()
        {
            FarPoint.Win.Spread.DrawingSpace.RectangleShape pRectangleShape = new FarPoint.Win.Spread.DrawingSpace.RectangleShape();
            pRectangleShape.BackColor = Color.Transparent;
            pRectangleShape.ShapeOutlineThickness = 2;
          
            
            int rowId = fpSpread1.ActiveSheet.ActiveCell.Row.Index;
            int colId = fpSpread1.ActiveSheet.ActiveCell.Column.Index;

            SheetView activeSheet = fpSpread1.ActiveSheet;

                //Gets the height of the rectangle shape.
                for (int pRow = rowId; pRow < rowId + 5; ++pRow)
                {
                    if (pRow == rowId)
                    {
                        pRectangleShape.Height = Convert.ToInt32(fpSpread1.ActiveSheet.Rows[pRow].Height) + 1;
                    }
                    else
                    {
                        pRectangleShape.Height += Convert.ToInt32(fpSpread1.ActiveSheet.Rows[pRow].Height);
                    }
                }

                //Gets the width of the rectangle shape.
                for (int pColumn = colId; pColumn < colId + 5; ++pColumn)
                {
                    if (pColumn == colId)
                    {
                        pRectangleShape.Width = Convert.ToInt32(fpSpread1.ActiveSheet.Columns[pColumn].Width) + 1;
                    }
                    else
                    {
                        pRectangleShape.Width += Convert.ToInt32(fpSpread1.ActiveSheet.Columns[pColumn].Width);
                    }
                }

                pRectangleShape.Locked = true;
                activeSheet.AddShape(pRectangleShape, rowId,colId);

        }
    }
}
